//
//  test47.cpp
//  Lecture3CPP
//
//  Created by presentations on 12/4/17.
//
//

#include <iostream>
using namespace std;

class DivideByZeroException {// handle throwing an exception on a division by 0
    public:
        DivideByZeroException()  :  message( "attempted to divide by zero" ) { }
        const string what() const { return message; }
    private:
        const string message;
}; // end class DivideByZeroException

// Definition of function quotient. Demonstrates throwing
// an exception when a divide-by-zero exception is encountered.
double quotient( int numerator, int denominator )
{
    if ( denominator == 0 )
        throw DivideByZeroException();  // an exception object  of any type!
    
    return static_cast< double > ( numerator ) / denominator;
} // end function quotient


int main()
{
    int number1, number2;
    double result;
    cout << "Enter two integers (end-of-file to end): ";
    
    while ( cin >> number1 >> number2 ) {    // cin returns a boolean value
        // the try block wraps the code that may throw an exception and
        // the code that should not execute if an exception occurs
        try {
            result = quotient( number1, number2 );
            cout << "The quotient is: " << result << endl;
        } // end try
        catch ( DivideByZeroException ex ) { // exception handler of any type!
            cout << "Exception occurred: " << ex.what() << '\n';
        } // end catch
        cout << "\nEnter two integers (end-of-file to end): ";
    } // end while
    cout << endl;
    return 0;      // terminate normally
} // end function main

