//
//  tstack.h
//  Lecture3CPP
//
//  Created by presentations on 12/4/17.
//
//

#ifndef TSTACK_H
#define TSTACK_H

template< class T >
class Stack {
public:
    Stack( int = 10 );    // default constructor (stack size 10)
    ~Stack() { delete [] stackPtr; } // destructor
    bool push( const T& ); // push an element onto the stack
    bool pop( T& );        // pop an element off the stack
private:
    int size;             // # of elements in the stack
    int top;              // location of the top element
    T *stackPtr;          // pointer to the stack
    
    bool isEmpty() const { return top == -1; }      // utility
    bool isFull() const { return top == size - 1; } // functions
}; // end class template Stack

// Constructor with default size 10
template< class T >
Stack< T >::Stack( int s )
{
    size = s > 0 ? s : 10;
    top = -1;                           // Stack is initially empty
    stackPtr = new T[ size ]; // allocate space for elements
} // end Stack constructor

// Push an element onto the stack. Return 1 if successful, 0 otherwise
template< class T >
bool Stack< T >::push( const T &pushValue )
{
    if ( !isFull() ) {
        stackPtr[ ++top ] = pushValue; // place item in Stack
        return true;  // push successful
    } // end if
    return false;     // push unsuccessful
} // end function template push

template< class T >
bool Stack< T >::pop( T &popValue ) // Pop an element off the stack
{
    if ( !isEmpty() ) {
        popValue = stackPtr[ top-- ];  // remove item from Stack
        return true;  // pop successful
    } // end if
    return false;     // pop unsuccessful
} // end function template pop

#endif
